function X = funct_mnare(A,B,C,D,X0)
% X=FUNCT_MNARE(A,B,C,D,X0) solves the M-NARE C + XA + DX - XBX = 0
% by means of a functional iteration 
%    A, B, C, D: matrix coefficients
%    X0: initial approximation
%    X : solution of the M-NARE
tol = 1e-13;
kmax = 50;
X = X0;
err = 1;
k = 0;
A1 = tril(A,1);
A2 = A1 - A;
D1 = tril(D,1);
D2 = D1 - D;
while err > tol && k < kmax
    W =  X*B*X + X*A2 + D2*X - C;
    X = sylvester(D1,A1,W);
    RX = C + X*A + D*X - X*B*X; 
    err = norm(RX,1)/norm(X,1)
    k = k + 1;
end
if k == kmax
    disp('Warning: reached the maximum number of iterations')
end
